<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to show all behaviour of linked list.</p>
		<button onclick="linked_List()">Linked List</button>
		<p id="demo"></p>

		<script>
			function linked_List() {
                // User defined class node 
                class Node { 
                    // constructor 
                    constructor(element) 
                    { 
                        this.element = element; 
                        this.next = null
                    } 
                } 

                // linkedlist class 
                class LinkedList { 
                    constructor() { 
                        this.head = null; 
                        this.size = 0; 
                    }   

                    // adds an element at the end of list 
                    add(element) { 
                        // creates a new node 
                        var node = new Node(element); 
    
                        // to store current node 
                        var current; 
    
                        // if list is Empty add the element and make it head 
                        if (this.head == null) 
                            this.head = node; 
                        else {
                            current = this.head; 
    
                            // iterate to the end of the list 
                            while (current.next) { 
                                current = current.next; 
                            } 
                            // add node 
                            current.next = node;  
                            this.size++; 
                        }
                    }  

                    countNodes(node) {  
                        var res = 1;  
                        var temp = node;  
                        while (temp.next != node) {  
                           res++;  
                           temp = temp.next;  
                        }  
                        return res;  
                    }  
                    
                    countNodesinLoop() {  
                        var slow_p = this.head, fast_p = this.head;  
                    
                        while (slow_p !=null && fast_p!=null && fast_p.next!=null)  {  
                            slow_p = slow_p.next;  
                            fast_p = fast_p.next.next;  
                            // If slow_p and fast_p meet at some point  then there is a loop
                                if (slow_p == fast_p)  
                                    return this.countNodes(slow_p);  
                        }  
                        /* Return 0 to indeciate that ther is no loop*/
                        return 0;  
                    }
                }

                // creating an object for the Linkedlist class 
                var linked_list = new LinkedList(); 
                linked_list.add(10); 
                linked_list.add(20); 
                linked_list.add(30); 
                linked_list.add(40); 
                linked_list.add(50); 
                linked_list.head.next.next.next.next = linked_list.head.next;

                console.log(linked_list.countNodesinLoop()); 


        }

		</script>

	</body>
</html>